#include <xc.h>
#include "user_define.h"

extern unsigned char	bank_no;
extern unsigned char	preset_no;
extern unsigned int		preset[PRESET_MAX];
extern unsigned int		khz_no;
extern unsigned char	mode;
extern unsigned char	width;
extern unsigned int    freq_no;

/*----------EEPROM----------*/
unsigned char E2promRead(unsigned char adr)
{
	EEADR=adr;
	RD=1;
	return(EEDATA);
}

void E2promWrite(unsigned char adr,unsigned char data)
{
	EEADR=adr;
	EEDATA=data;
	
	WREN=1;
	EECON2=0x55;
	EECON2=0xaa;
	
	WR=1;
	while(EEIF==0)
	{
		NOP();
	}
	EEIF=0;
	WREN=0;
}

void	eeprom_write_sub(void)
{
unsigned char	i;

	for(i=0;i<PRESET_MAX;i++){
		E2promWrite(bank_no*0x30+0x10+i*2,(unsigned char)(preset[i]%256));
		E2promWrite(bank_no*0x30+0x11+i*2,(unsigned char)(preset[i]/256));
	}
}

void	eeprom_init(void)
{
unsigned char	i;

		preset[0]=FREQ_MAX;

		for(i=1;i<PRESET_MAX;i++){
			preset[i]=0;
		}
		
		khz_no=FREQ_MIN;
		
		E2promWrite(0x00,0xa5);
		
		bank_no=0;eeprom_write_sub();
		E2promWrite(bank_no*0x30+0x0a,(unsigned char)(khz_no%256));
		E2promWrite(bank_no*0x30+0x0b,(unsigned char)(khz_no/256));
		E2promWrite(bank_no*0x30+0x08,preset_no);
		E2promWrite(bank_no*0x30+0x05,mode);
		E2promWrite(bank_no*0x30+0x06,(unsigned char)freq_no);        
		
		bank_no=1;eeprom_write_sub();
		E2promWrite(bank_no*0x30+0x0a,(unsigned char)(khz_no%256));
		E2promWrite(bank_no*0x30+0x0b,(unsigned char)(khz_no/256));
		E2promWrite(bank_no*0x30+0x08,preset_no);
		E2promWrite(bank_no*0x30+0x05,mode);
		E2promWrite(bank_no*0x30+0x06,(unsigned char)freq_no);         

		bank_no=2;eeprom_write_sub();
		E2promWrite(bank_no*0x30+0x0a,(unsigned char)(khz_no%256));
		E2promWrite(bank_no*0x30+0x0b,(unsigned char)(khz_no/256));
		E2promWrite(bank_no*0x30+0x08,preset_no);
		E2promWrite(bank_no*0x30+0x05,mode);
		E2promWrite(bank_no*0x30+0x06,(unsigned char)freq_no);         

		bank_no=0;
		E2promWrite(0x0c,bank_no);

		width=2;
		/*E2promWrite(0x0e,width);*/

}
void	eeprom_read_preset(void)
{
unsigned char	i;
unsigned int sub0,sub1;

		for(i=0;i<PRESET_MAX;i++){
			sub0=(unsigned int)E2promRead(bank_no*0x30+0x10+i*2);
			sub1=(unsigned int)E2promRead(bank_no*0x30+0x11+i*2);
			preset[i]=sub0+sub1*256;
		}
}

void	eeprom_check(void)
{
unsigned int sub0,sub1;

	if(E2promRead(0x00)==0xa5){
		bank_no=E2promRead(0x0c);
		/*width=E2promRead(0x0e);*/
		width=2;
		sub0=(unsigned int)E2promRead(bank_no*0x30+0x0a);
		sub1=(unsigned int)E2promRead(bank_no*0x30+0x0b);
		khz_no=sub0+sub1*256;
		preset_no=E2promRead(bank_no*0x30+0x08);
		mode=E2promRead(bank_no*0x30+0x05);
        freq_no=E2promRead(bank_no*0x30+0x06);
		eeprom_read_preset();
		
	}
	else{
		eeprom_init();
	}
}

void	write_direct(void)
{
		E2promWrite(0x0c,bank_no);
		E2promWrite(bank_no*0x30+0x0a,(unsigned char)(khz_no%256));
		E2promWrite(bank_no*0x30+0x0b,(unsigned char)(khz_no/256));
		E2promWrite(bank_no*0x30+0x08,preset_no);
		E2promWrite(bank_no*0x30+0x05,mode);
		E2promWrite(bank_no*0x30+0x06,(unsigned char)freq_no);         
}
void	write_direct_set(unsigned char	no)
{
		E2promWrite(bank_no*0x30+0x10+no*2,(unsigned char)(preset[no]%256));
		E2promWrite(bank_no*0x30+0x11+no*2,(unsigned char)(preset[no]/256));
}
void	write_direct_width(void)
{
		/*E2promWrite(0x0e,width);*/
}